

dofile("datadumper.lua")
dofile("keys.lua")
tmp_skeletonlist={}
tmp_zombilist={}
tmp_zspawnlist={}
tmp_bzombilist={}
tmp_brobotlist={}
tmp_soldierlist={}
tmp_bsoldierlist={}
tmp_turretlist={}
tmp_soldiertable={} --kustuta hiljem 'ra
tmp_itemspawntable={}
tmp_rareitemspawntable={}
rnddestructiontable={}
tmp_containertable={}

texturelist={}
spritelist={}
soundlist={}
objectlist={}

scripttable={}

currenttransform={x=0,y=0,a=0}

function SaveSettings()
	local file=io.open("settings.lua","w")
	local settingstable=DataDumper(settings,"settings",true)
	file:write(settingstable)
	file:close()
end

function LoadSettings()
	local fn,err=loadfile("settings.lua")
	if not fn then
		print("Error loading settings: "..err)
		settings={}
	else
		fn()
	end
end

function LoadTexture(url,name)
	texturelist[name]=_LoadTexture(url,name)
end

function GetTexture(name)
	if texturelist[name]==nil then
		print("texture " .. name .. " does not exist\n")
		return 0
	else
		return texturelist[name]
	end	
end

function LoadSound(name,volume,...)
	soundlist[name]=_LoadSound(volume, unpack(arg))
end

function GetSound(name)
	if soundlist[name]==nil then
		print("sound " .. name .." does not exist\n")
		return 0
	else
		return soundlist[name]
	end	
end

function CreateSprite(name,texname,numx,numy,w,h,xoffset,yoffset)
	if xoffset==nil then xoffset=0 end
	if yoffset==nil then yoffset=0 end
	spritelist[name]=_CreateSprite(texname,numx,numy,w,h,xoffset,yoffset)
end

function GetSprite(name)
	if spritelist[name]==nil then
		print("sprite " .. name .." does not exist\n")
		return 0
	else
		return spritelist[name]
	end	
end

cbool={}
cbool[true]=1
cbool[false]=0

function SetDefault (t, d)
  local mt = {__index = function () return d end}
  setmetatable(t, mt)
end
function string:split(sep)
	local sep, fields = sep or ":", {}
	local pattern = string.format("([^%s]+)", sep)
	self:gsub(pattern, function(c) fields[#fields+1] = c end)
	return fields
end

listFiles=function(path,ext)
	local list=_PrintDirectory(path)

	
	local split_list=list:split("\n");

	local retlist={}
			
	for k,v in pairs(split_list) do
		if string.find(v,"." .. ext,1,true) then
		table.insert(retlist,v)
		end
	end
	return retlist
end
testrot=0

do
	local cLoadLevel=LoadLevel
	LoadLevel=function(dir,preservestatus)
		ClearModules()
		LoadModules()
		scripttable={}
		cLoadLevel(dir,preservestatus)
	end
end

do 
	local cCreateNode=CreateNode
	CreateNode=function(x,y,a,typ)
--		if typ==nil then typ=0 end
		cCreateNode(x,y,a,typ)
		local tx,ty,ta=GetCreationTransform()
		local nx,ny=TransformPoint(x,y,tx,ty,ta)
		if typ==1 then
			table.insert(tmp_itemspawntable,{x=nx,y=ny})
		end
		if typ==2 then
			table.insert(tmp_rareitemspawntable,{x=nx,y=ny})
		end
	end
end

function table.find(value, l)
  for k, v in pairs(l) do
	if (v==value) then
      return k
    end
  end
  return nil
end

do 
	local cfunc=actor.GetAction
	actor.GetAction=function(a)
	local nr=cfunc(a)
	return table.find(nr,actions)
	end
end
	
function PlaceModule(x,y,a,modname)
	if modlist[modname] then
		SetCreationTransform(x,y,a)
		modlist[modname].CreateObjects()
		SetCreationTransform(0,0,0)
	else
		print("ERROR:Module " .. modname .. "does not exist\n")
	end
end

function LoadModules()
	modlist={}
	local modules=listFiles("./mods/","lua")
	
	for k,v in pairs(modules) do
		dofile("./mods/" .. v)
	end

	for k,v in pairs(modlist) do
		AddModule(k)
	end
end

function PlaceAllModules()
	local mody=0
	for k,v in pairs(modlist) do
		mody=mody+v.h*0.6
		PlaceModule(0,mody,0,k)
		SetCreationTransform(0,0,0)
		CreateTextObj(v.h*0.6,mody,k)
		mody=mody+v.h*0.6
	end
end

function table.copy(t)
	local t2 = {}
	for k,v in pairs(t) do
		t2[k] = v
	end
	return t2
end

function table.copyadd(src,dst)
	for k,v in pairs(src) do
		dst[k] = v
	end
end

function IntersectOBB(obb1,obb2)
	return _IntersectOBB(obb1.x,obb1.y,obb1.a,obb1.w,obb1.h,obb2.x,obb2.y,obb2.a,obb2.w,obb2.h)
end

--modules={"module1","module2"}
--itemlist["item_name"]=10
--rareitemlist["item_name"]=10
--enemylist["zombie"]=20
--deadendtable={"deadendmodule1","deadendmodule1"}
function GenerateLevel(modules,itemlist,rareitemlist,citemlist,enemylist,deadendtable,maxtries,pstart)
	local tries=0
	local modules2=table.copy(modules)
	while GenerateLevelIteration(modules2,itemlist,rareitemlist,citemlist,enemylist,deadendtable,pstart)==-1 do
		modules2=table.copy(modules)
		
		tries=tries+1
		if tries>=maxtries then
			print("Level generation failed, try again\n")
			break 
		else
			ClearLevel()
		end
	end
end
function AddToRndTable(ptr,name)
	if rnddestructiontable[name]==nil then
		rnddestructiontable[name]={}
		rnddestructiontable[name].count=0
	end
	table.insert(rnddestructiontable[name],ptr)		
end
function GenerateLevelIteration(modules,itemlist,rareitemlist,citemlist,enemylist,deadendtable,pstart)
	SetDefault(enemylist,0)
	SetDefault(itemlist,0)
	SetDefault(rareitemlist,0)
	SetDefault(citemlist,0)

	rnddestructiontable={}
	for k,v in pairs(enemylist) do
		rnddestructiontable[k]={}
		rnddestructiontable[k].count=v		
	end
	--[[tmp_skeletonlist={}
	tmp_zombilist={}
	tmp_zspawnlist={}
	tmp_bzombilist={}
	tmp_brobotlist={}
	tmp_soldierlist={}
	tmp_bsoldierlist={}
	tmp_soldiertable={} --kustuta hiljem 'ra
]]--
	tmp_itemspawntable={}
	tmp_rareitemspawntable={}
	tmp_containertable={}

	if enemylist["zspawner"]==nil then enemylist["zspawner"]=10 end
	placedmodlist={}
	nodelist={}
	--pane paika algusmoodul
	-----------------------
	print("---\n")
	local rot=math.random(6.282)
	PlaceModuleLevel(0,0,rot,modules[1]) 
	table.remove(modules,1)

	--pane paika mngija
	SetCreationTransform(0,0,rot)
	CreatePlayer(pstart.x,pstart.y)
	SetCreationTransform(0,0,0)

	local cycles=0		--loeb genereerimise tskleid, et vimatu kombinatsioon ei tekitaks infinite loopi
	local max_cycles=500
	--paiguta moodulid ja kollid
	while modules[1] do
		if modlist[modules[1]]==nil then
			print("Module " .. modules[1] .. " not found!\n")
			print("fail\n")
			return -1
		end
		
		local gatenr=math.random(#nodelist)
		local spot=nodelist[gatenr]
		
		local gatenr2=math.random(#modlist[modules[1]])
		local spot2=table.copy(modlist[modules[1]][gatenr2])

		--teise yhenduskoha nurk peab olema 180 kraadi esimese omast.
		local turn=spot2.a+3.141-spot.a
		spot2.x,spot2.y=TransformPoint(spot2.x,spot2.y,0,0,-turn)
		cycles=cycles+1
		if PlaceModuleLevel(spot.x-spot2.x,spot.y-spot2.y,-turn,modules[1],gatenr2) then
			table.remove(nodelist,gatenr)
			table.remove(modules,1)
		end
		if cycles>max_cycles then
			print("fail\n")
			return -1
		end
	end
	print("---\n")
	
	--paiguta tupikud
	while nodelist[1] do
		local spot=nodelist[1]
		local modname=deadendtable[math.random(#deadendtable)]
		if modlist[modname]==nil then print("ERROR:module ".. modname .. " does not exist!\n")  return end
		local spot2=table.copy(modlist[modname][1])

		local turn=spot2.a+3.141-spot.a
		spot2.x,spot2.y=TransformPoint(spot2.x,spot2.y,0,0,-turn)
		
		PlaceModule(spot.x-spot2.x,spot.y-spot2.y,-turn,modname)
		table.remove(nodelist,1)
	end

	--kustuta liigsed vaenlased
	---------------------------------------------------
	for k,v in pairs(rnddestructiontable) do
		while #v>v.count do
			local deletenr=math.random(#v)
			object.Delete(v[deletenr])
			table.remove(v,deletenr)
		end	
	end

	local containercount=#tmp_containertable/2
	while #tmp_containertable>containercount do
		local deletenr=math.random(#tmp_containertable)
		object.Delete(tmp_containertable[deletenr])
		table.remove(tmp_containertable,deletenr)
	end

	SetCreationTransform(0,0,0)

	--paiguta hea nodi
	----------------------------------------------------
	for k,v in pairs(itemlist) do
		for i=0,v-1 do
			local randpos=tmp_itemspawntable[math.random(#tmp_itemspawntable)]
			CreateItem(randpos.x+math.random(-3,3)/24,randpos.y+math.random(-3,3)/24,k)
		end
	end
	
	for k,v in pairs(rareitemlist) do
		for i=0,v-1 do
			local randpos=tmp_rareitemspawntable[math.random(#tmp_rareitemspawntable)]
			CreateItem(randpos.x+math.random(-3,3)/24,randpos.y+math.random(-3,3)/24,k)
		end
	end
	for k,v in pairs(citemlist) do
		for i=0,v-1 do
			local dest=tmp_containertable[math.random(#tmp_containertable)]
			container.AddItem(dest,k)
		end
	end
	return 0;
end

function PlaceModuleLevel(x,y,a,module,spotnr)
	local md=modlist[module]
	if md==nil then print("Module " .. module .. " does not exist\n") return 0 end

	local coltbl={x=x,y=y,a=a,w=-md.w*0.9,h=-md.h*0.9}
	local collide=0
	for k,v in pairs(placedmodlist) do
		collide=IntersectOBB(coltbl,v)
		if collide==1 then return false end 
	end
	PlaceModule(x,y,a,module)
	print(module .. "\n")
	table.insert(placedmodlist,coltbl)
	for i,v in ipairs(md) do
		if i~=spotnr then 
			local rx,ry=TransformPoint(v.x, v.y, x, y, a)
			local ra=v.a+a
			table.insert(nodelist,{x=rx,y=ry,a=ra})
		end
	end
	return true
end

do
	local cCreateContainer=CreateContainer
	CreateContainer=function(x,y,angle,sprname)
		table.insert(tmp_containertable,cCreateContainer(x,y,angle,sprname))
	end
end

